/**
 * Copyright 2018 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *     http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
declare const enum Status {
    RESOLVE = 0,
    REJECT = 1
}
export interface Task<T = any> {
    id: number;
    $$taskIdentifier: string;
    $$taskResult?: T;
}
export interface Result<T = any, E = string | Error> extends Promise<T> {
    state?: Status;
    fulfilled?: boolean;
    value?: T;
    error?: E;
}
export interface ProcessorConstructor {
    new (): Processor;
}
export interface Processor {
    process(...args: any[]): any;
}
export declare function registerTask(name: string, processor: ProcessorConstructor): void;
export {};
