/**
 * Copyright 2018 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *     http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare type Key = string | number;
declare type Reducer<T> = (accumulator: Partial<T> | void, obj: any, index: Key, parent: any) => Partial<T> | void;
export declare function walkReduce<T = any>(obj: any, reducer: Reducer<T>, accumulator?: Partial<T> | void, index?: Key, parent?: any): void | Partial<T>;
declare type Transferrables = ArrayBuffer | MessagePort | ImageBitmap;
export declare function collectTransferrables<T = any>(xfer: Transferrables[], value: T): void;
export {};
